/*
 * common.h
 *
 *  version 0.10  february 3, 1997
 *  jeremy wohl (jeremyw@anders.com)
 *  no warranty, no responsibility, etc.
 *
 */

typedef struct {
    char  user [101], host [101], service [101], action [101];
    char  data [1001];

    int   time_sec, time_usec, recv_sec, delay, hops;
} trigger_t;

typedef enum { false = 0, true } bool;

extern void die_quick (int);
extern void die_slowly (void);
extern void nomem_sleep (void);

extern rc_getmatch (const char * user, const char * service,
		    const char * action, const char * data,
		    const char * home, char ** command);

extern void * queue_create (void);
extern void   queue_free (void *);
extern int    queue_items (void *);
extern void   queue_lock (void *);
extern void   queue_unlock (void *);
extern void   queue_sem_wait (void *);
extern int    queue_sem_trywait (void *);
extern void   queue_add (void *, void *);
extern void * queue_front (void *);
extern void   queue_remove (void *);
