/*
 * triggerlib.c
 *
 *  version 0.10  february 3, 1997
 *  jeremy wohl (jeremyw@evantide.com)
 *  no warranty, no responsibility, etc.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#include "trigger.h"
#include "triggermsg.h"

/* returns: 0 success, 1 param error, 2 temporary error, 3 permanent error */
int trigger (const char * user, const char * service, const char * action,
	     const char * data)
{
    struct trigger_msg  buf;
    struct timeval      tv;

    char     str [10];
    FILE   * fp;
    int      msqid, result;
    int      ul, sl, al, dl;


    gettimeofday (&tv, 0);

    if ((fp = fopen ("/var/run/triggerd.msqid", "r")) == 0)  return (3);
    if (      fgets (str, 10, fp)                     == 0)  return (3);
    fclose (fp);

    msqid = atoi (str);

    ul = strlen (user);
    sl = strlen (service);
    al = strlen (action);
    dl = data ? strlen (data) : 0;

    if (ul ==  0 || sl ==  0 || al ==  0)               return (1);
    if (ul > 100 || sl > 100 || al > 100 || dl > 1000)  return (1);

    buf.mtype   = 1;
    buf.version = 1;

    strcpy (buf.user,    user);
    strcpy (buf.service, service);
    strcpy (buf.action,  action);

    if (dl)  strcpy (buf.data, data);  else buf.data [0] = 0;

    buf.time_sec  = tv.tv_sec;
    buf.time_usec = tv.tv_usec;
    buf.delay     = 0;
    buf.hops      = 0;

    result = msgsnd (msqid, (struct msgbuf *) &buf, sizeof buf, IPC_NOWAIT);

    if (result == -1 && (errno == EAGAIN || errno == EINTR))  return (2);
    if (result == -1)                                         return (3);
	
    return (0);
}
